#load the spectral data all together
setwd("E:/S2Slope_grassland")
wuyispec <- read.table("E:/S2Slope_grassland/asd08GNP.txt", header=T,sep="\t",quote="")
names(wuyispec)


##### For loop for all the results together
print(ncol(wuyispec))
wavelength <- wuyispec[,1]
results<-data.frame(site="site",R_seg="R_seg",NIR_seg="NIR_seg",G_Rslope="G_Rslope",rededge_slope="rededge_slope",NIR_slope="NIR_slope",NDVIhyper="NDVIhyper",Rmin="Rmin",NDVIt="NDVIt")
for (i in 2:ncol(wuyispec)){
    site <- wuyispec[,i]
	  col_data <- cbind(wavelength,site)
  	col_data <- as.data.frame(col_data)
	  asd.seg<-segmented(glm(site~wavelength,data = col_data), seg.z=~wavelength, psi=c(0.67,0.76))
	  data_1<-subset(col_data,wavelength<asd.seg$psi[3])
	  data_2<-subset(col_data,wavelength>asd.seg$psi[3]& wavelength<asd.seg$psi[4])
	  data_3<-subset(col_data,wavelength>asd.seg$psi[4])
	  mod1<-lm(site~wavelength,data=data_1)
	  mod2<-lm(site~wavelength,data=data_2)
	  mod3<-lm(site~wavelength,data=data_3)
	  R1 = subset(col_data,wavelength==0.67)[,2]
	  NIR = subset(col_data,wavelength==0.8)[,2]
	  NDVIhyper1 = (NIR-R1)/(NIR+R1)
	  R_data<-subset(col_data,wavelength >= 0.60 & wavelength < asd.seg$psi[3])
	  R = min(R_data[,2])
	  Rw= subset(col_data,site==R)[,1]
	  NDVIt1 = (NIR-R)/(NIR+R)
	  G_Rslope=mod1$coefficients[2]
	  G_Rslope<-as.data.frame(G_Rslope)
	  rededge_slope=mod2$coefficients[2]
	  rededge_slope<-as.data.frame(rededge_slope)
	  NIR_slope=mod3$coefficients[2]
	  NIR_slope<-as.data.frame(NIR_slope)
	  newline <- data.frame(t(c(site = names(wuyispec[i]),R_seg=asd.seg$psi[3],NIR_seg=asd.seg$psi[4],G_Rslope=G_Rslope[1,1],rededge_slope=rededge_slope[1,1],NIR_slope=NIR_slope[1,1],NDVIhyper=NDVIhyper1,Rmin=Rw,NDVIt=NDVIt1)))
	  results <- rbind(results, newline)
	  print(i)
	}
write.table(results, file = "results.csv", row.names = FALSE, append = FALSE, col.names = FALSE, sep = ", ")	